<template>
	<section class="FieldsViewControls grey lighten-4" aria-label="filters">
		<div class="FieldsViewControl-searchInputContainer">
			<fields-view-search-input></fields-view-search-input>
			<span v-if="isLoaded" class="FieldsViewControls-resultsDisplay v-messages theme--light"
				>{{ numberOfResults }} results</span
			>
		</div>

		<div class="FieldsViewControls-filters">
			<v-menu offset-y :close-on-content-click="false" v-model="showGroupFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined> Group </v-btn>
				</template>
				<fields-view-group-filter
					class="FieldsViewControls-control"
					@ok="showGroupFilter = false"
					:useDesktopLayout="true"
				></fields-view-group-filter>
			</v-menu>

			<v-menu offset-y :close-on-content-click="false" v-model="showRecentActivityFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined> Recent Activity </v-btn>
				</template>
				<fields-view-recent-activity-filter
					class="FieldsViewControls-control"
					@ok="showRecentActivityFilter = false"
					:useDesktopLayout="true"
				></fields-view-recent-activity-filter>
			</v-menu>

			<v-menu offset-y :close-on-content-click="false" v-model="showStatusFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined>Status</v-btn>
				</template>
				<fields-view-status-filter
					class="FieldsViewControls-control"
					@ok="showStatusFilter = false"
					:useDesktopLayout="true"
				></fields-view-status-filter>
			</v-menu>

			<button class="FieldsViewControls-clearAll primary--text" @click="clearAllFilters">Clear all filters</button>
		</div>
	</section>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@vue/composition-api';
import FieldsViewSearchInput from './FieldsViewSearchInput.vue';
import FieldsViewGroupFilter from './FieldsViewGroupFilter.vue';
import FieldsViewRecentActivityFilter from './FieldsViewRecentActivityFilter.vue';
import FieldsViewStatusFilter from './FieldsViewStatusFilter.vue';
import { useAllResources } from '@/store/modules/resources';

export default defineComponent({
	components: {
		FieldsViewSearchInput,
		FieldsViewGroupFilter,
		FieldsViewRecentActivityFilter,
		FieldsViewStatusFilter,
	},
	setup(_, { root }) {
		const showGroupFilter = ref(false);
		const showRecentActivityFilter = ref(false);
		const showStatusFilter = ref(false);
		const numberOfResults = computed(() => root.$store.getters['fieldsView/getFieldRowsLength']);
		const { isLoaded } = useAllResources(root.$store);

		return {
			showGroupFilter,
			showRecentActivityFilter,
			showStatusFilter,
			numberOfResults,
			isLoaded,
			clearAllFilters: () => {
				root.$store.dispatch('fieldsView/clearAllFilters');
			},
		};
	},
});
</script>

<style>
.FieldsViewControls {
	display: flex;
	flex-wrap: wrap;
	margin: 0 16px;
}

.FieldsViewControls-resultsDisplay {
	position: absolute;
	right: 0;
	bottom: 7px;
}

.FieldsViewControls-menuButton {
	background: #fff;
}

.FieldsViewControls-control {
	min-width: 150px;
}

.FieldsViewControls .FieldsViewControl-searchInputContainer {
	position: relative;
	width: 300px;
	max-width: 300px;
	margin-right: 16px;
}

@media (max-width: 847px) {
	.FieldsViewControls .FieldsViewControl-searchInputContainer {
		width: 100%;
		max-width: 100%;
		margin-right: 0;
	}
}

.FieldsViewControls .FieldsViewControls-filters {
	height: 40px;
	margin-bottom: 12px;
	min-width: 500px;
}

.FieldsViewControls-filters > *:not(:last-child) {
	margin-right: 16px;
}

.FieldsViewControls-filters > .v-btn {
	height: 100% !important; /* match search input height */
}
</style>
